
/*********************************************************************************************
		ƣ    ɵ
		ַ    www.51c51.net
		ߣ    
		Q  Q:     501501561 
		E-MAIL:   atc51@163.com
/*********************************************************************************************/
/*********************************************************************************************
		:  HT1621оƬԳ 
		ʱ䣺20101018 
		CPU STC89SC52RC 	STC10F04  STC12C5A32S2  12MHZ /11.0592M
		壺ɵ QEϵп
		˵: ԳܹHT1621ÿһֶΣε ÿһֶ
		ƬIOڷֲ
		sbit HT1621_DAT=P1^2;   //HT1621 
		sbit HT1621_CS =P1^0;    //HT1621ʹ 
		sbit HT1621_WR =P1^1;    //HT1621ʱ 
/*********************************************************************************************/

#include <REG51.H> 
#include <intrins.h> 

#define uchar unsigned char 
#define uint unsigned int 
#define _Nop() _nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_() ;_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_()

#define BIAS   0x52 //0b1000 0101 0010  1/3duty 4com 

#define SYSDIS 0X00    //0b1000 0000 0000  ϵͳLCDƫѹ 
#define SYSEN  0X02    //0b1000 0000 0010 ϵͳ 

#define LCDOFF 0X04    //0b1000 0000 0100  LCDƫѹ 
#define LCDON  0X06    //0b1000 0000 0110  LCDƫѹ 

#define XTAL   0x28    //0b1000 0010 1000 ⲿʱ 
#define RC256  0X30    //0b1000 0011 0000  ڲʱ 

#define TONEON  0X12    //0b1000 0001 0010   
#define TONEOFF 0X10    //0b1000 0001 0000 ر 

#define WDTDIS  0X0A //0b1000 0000 1010  ֹŹ 

//HT1621λҺģӿڶ壬ѵҪģ 
sbit HT1621_DAT=P1^2; //HT1621 
sbit HT1621_CS=P1^0;    //HT1621ʹ 
sbit HT1621_WR=P1^1;    //HT1621ʱ 


uchar code Ht1621Tab[]={0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}; 

//delay us ʱ
void Delay(uchar us)  //5,7,9 
{ 
 while(--us);  
} 


//delay ms 
void DelayMS(uint iMs) 
{ 
 uint i,j; 
   for(i=0;i<iMs;i++) 
    for(j=0;j<65;j++) Delay(1); 
       
} 
/****************************************************** 
дݺ,cntΪλ,ݴΪλǰ 
*******************************************************/ 
void Ht1621Wr_Data(uchar Data,uchar cnt) 
{ 
  uchar i; 
  for (i=0;i<cnt;i++) 
  {   
    HT1621_WR=0; 
_Nop(); 
HT1621_DAT=Data&0x80;        
    _Nop(); 
    HT1621_WR=1; 
    _Nop(); 
    Data<<=1;  
  } 
} 
/******************************************************** 
ƣvoid Ht1621WrCmd(uchar Cmd) 
: HT1621д뺯 
ȫֱ 
˵CmdΪд 
˵ 
  ˣɵ www.51c51.net
    V2.0 
˵    дʶλ100 
ʱ䣺2010-10-18
********************************************************/ 
void Ht1621WrCmd(uchar Cmd) 
{ 
  HT1621_CS=0; 
  _Nop(); 
  Ht1621Wr_Data(0x80,4); //д־100 
  Ht1621Wr_Data(Cmd,8); //д 
  HT1621_CS=1; 
  _Nop();  
} 
/******************************************************** 
ƣvoid Ht1621WrOneData(uchar Addr,uchar Data) 
: HT1621ַָдݺ 
ȫֱ 
˵AddrΪдʼַDataΪд 
˵ 
  ˣɵ www.51c51.net
    V2.0 
˵    ΪHT1621λ4λʵдΪĺ4λ 
ʱ䣺2010-10-18
********************************************************/ 
void Ht1621WrOneData(uchar Addr,uchar Data) 
{ 
  HT1621_CS=0; 
  Ht1621Wr_Data(0xa0,3); //дݱ־101 
  Ht1621Wr_Data(Addr<<2,6); //дַ 
  Ht1621Wr_Data(Data<<4,4); //д 
  HT1621_CS=1;   
  _Nop();  
} 

/******************************************************** 
ƣvoid Ht1621WrAllData(uchar Addr,uchar *p,uchar cnt) 
: HT1621д뷽ʽ 
ȫֱ 
˵AddrΪдʼַ*pΪдָ룬 
cntΪд 
˵ 
  ˣɵ www.51c51.net
    V2.0 
˵    HT1621λ4λ˴ÿΪ8λд 
8λ 
ʱ䣺2010-10-18
********************************************************/ 
void Ht1621WrAllData(uchar Addr,uchar *p,uchar cnt) 
{ 
  uchar i; 
  HT1621_CS=0; 
  Ht1621Wr_Data(0xa0,3); //дݱ־101 
  Ht1621Wr_Data(Addr<<2,6); //дַ 
  for (i=0;i<cnt;i++) 
  { 
   Ht1621Wr_Data(*p,8); //д 
p++; 
  } 
  HT1621_CS=1;   
  _Nop();  
} 



/******************************************************** 
ƣvoid Ht1621_Init(void) 
: HT1621ʼ 
ȫֱ 
˵ 
˵ 
  ˣɵ www.51c51.net
    V2.0 
˵    ʼҺֶξʾ 
ʱ䣺2010-10-18
********************************************************/ 
void Ht1621_Init(void) 
{ 
  HT1621_CS=1; 
 _Nop(); 
  HT1621_WR=1; 
  _Nop(); 
  HT1621_DAT=1; 
  _Nop(); 
  DelayMS(2000);      //ʱʹLCDѹȶ 
  Ht1621WrCmd(BIAS); 
  Ht1621WrCmd(RC256);     //ʹڲ 
  Ht1621WrCmd(SYSDIS); 
  Ht1621WrCmd(WDTDIS); 
  Ht1621WrCmd(SYSEN); 
  Ht1621WrCmd(LCDON); 
} 

/******************************************************** 
ƣmain() 
: 
  ˣɵ www.51c51.net
    V2.0 
ʱ䣺2010-10-18
********************************************************/
void main() 
{ 
  uchar i,j,t; 
  Ht1621_Init();     //ϵʼLCD 
   DelayMS(100); //ʱһʱ 
  Ht1621WrAllData(0,Ht1621Tab,16);//1621Ĵݣ 
  while(1){ 
for (i=0;i<32;i++) 
{ 
t=0x01; 
for (j=0;j<4;j++) 
{ 
Ht1621WrOneData(i,t); 
t<<=1; 
t++; 
DelayMS(500); 
} 

}    
  } 
}